
class FlushClass
end

Flush = FlushClass.new


class Appender
  def <<( str )
    if str.is_a?( FlushClass )
      return @data
    end
    @data = @data.to_s << str.to_s << "\n"
    self
  end
end

class ArgValue
  def initialize( type, name )
    self.type = type
    self.name = name
  end
  attr_accessor( :type, :name )

  def inspect
    "[type:#{self.type} name:#{self.name}]"
  end
end


interfaces = []

count = 0
STDIN.each_line{|line|
  count += 1
  line.chomp!
  if /SQUIRREL_API ([^ ]+) (sq(std)?_([^ \(]+))(.*);/.match( line )
    return_value = $1
    sq_func_name = $2
    is_standard = $3
    func_name = $4
    arg_str = $5

    need_result_check = /SQRESULT/.match( return_value )
    cpp_func_name = func_name.capitalize

    cpp_args = []
    raw_args = []
    sq_args = []
    if /\((.*)\)/.match( arg_str )
      tmp = $1
      args = []
      while tmp != ""
        /([^,]+)/.match( tmp )
        args << $1.strip
        tmp = $'.strip
      end
      args.each {|one|
        /((const +)?[^ ]+( \*)?)( ?([^ ]*))?/.match( one )
        raw_args << ArgValue.new( $1.dup, $5.dup )
        sq_args << ArgValue.new( $1.dup, $5.dup )
      }

      is_vm_first = raw_args.first.type == "HSQUIRRELVM" and raw_args.first.name == "v"
      sq_args.shift if is_vm_first

      sq_args.each{|one|
        one.name =
        case one.name
        when "idx"
          "index"

        when "p"
          "pointer"

        when "o", "obj"
          "object"

        when "t"
          "type"

        when "b"
          "flag"

        when "", nil
          "TODO"
        else
          one.name
        end
      }

      sq_args.each{|one|
        tmp =
        case one.type
        when "SQInteger"
          "int"

        when "SQUnsignedInteger"
          "unsigned int"

        when "const SQChar *"
          "const char*"

        when "SQUserPointer"
          "void*"

        when "SQBool"
          "bool"

        when "SQFloat"
          "float"

        when "", nil
          raise
        else
          one.type
        end
        cpp_args << ArgValue.new( tmp, one.name )
      }
    end
    data = Appender.new <<
    "void" <<
    (
      tmp =
      if is_standard
        "NativeAPI::Standard::#{cpp_func_name}"
      else
        "NativeAPI::#{cpp_func_name}"
      end
      tmp << 40.chr.to_s
      cpp_args.each{|one|
        tmp << " #{one.type} #{one.name},"
      }
      tmp.chop! if tmp[-1] == 44.chr
      tmp << " "
      tmp.chop! if tmp[-2] == 40.chr
      tmp << ")"
      tmp.gsub!( /\(\)$/, "( void )" )
      tmp
    ) <<
    123.chr.to_s <<
    (
      func_call_str = sq_func_name.dup
      func_call_str << 40.chr
      if is_vm_first
        func_call_str << " vm_,"
      end
      cpp_args.each{|one|
        func_call_str << " " << one.name << ","
      }
      func_call_str.chop! if func_call_str[-1] == 44.chr
      func_call_str << " "
      func_call_str.chop! if func_call_str[-2] == 40.chr
      func_call_str << ")"
      if need_result_check
        "ResultTest( #{func_call_str}, FUNC_NAME_OF( #{sq_func_name} ) );"
      elsif return_value == "void"
        "#{func_call_str};"
      else
        "#{return_value}\n" <<
        "#{func_call_str};"
      end
    ) <<
    "}" <<
    "" <<
    Flush
    print data
  end
  if count == 0
    break
  end
}


