#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <string>

#include "ttl_define.h"

#include "tt_squirrel_class_binder.h"
#include "tt_squirrel_exception.h"
#include "tt_squirrel_operation.h"

using namespace TtSquirrel;


class Foo {
public:
  explicit Foo( int x ) : x_( x ) {}
  
  void Bar( void ) {
    PCI( x_ );
  }
  void Baz( void ) {
    PCI( x_ * 2 );
  }
private:
  unsigned int x_;
};


class FooBinder : public ClassBinder<Foo> {
public:
  explicit FooBinder( VirtualMachine& vm ) : ClassBinder<Foo>( vm ) {}
  
  static int Bar( VirtualMachine& vm, Foo& foo ) {
    CheckArgumentsCount( vm, 0 );
    foo.Bar();
    vm.Native().PushInteger( 1000 );
    return 1;
  }
  static int Baz( VirtualMachine& vm, Foo& foo ) {
    CheckArgumentsCount( vm, 0 );
    foo.Baz();
    vm.Native().PushInteger( 2000 );
    return 1;
  }
};


int
main( int argc, char *argv[] )
{
  NOT_USE_VAR( argc );
  NOT_USE_VAR( argv );
  try {
    VirtualMachine vm;
PCI( vm.Native().GetTop() );
    vm.DoFile( "../test/test.nut" );

PCI( vm.Native().GetTop() );

    FooBinder foo_binder( vm );

PCI( vm.Native().GetTop() );

    Foo foo1( 100 );
    Foo foo2( 200 );
PCP( &foo1 );
PCP( &foo2 );

PCD();
    foo_binder.RegistMethodByName( "bar", FooBinder::Bar );
    foo_binder.RegistMethodByName( "baz", FooBinder::Baz );
PCD();

PCP( vm.GetHandle() );
PCP( vm.Native().GetHandle() );
PCP( NativeAPI::PushRootTable );

    vm.NewSlot(
      MakeOperation( vm.Native(), NativeAPI::PushInteger, Arg( 100 ) ),
      // MakeOperation( vm.Native(), NativeAPI::PushRootTable ),
      MakeOperation( vm.Native(), NativeAPI::PushString, Arg( "foo1" ) ),
      MakeOperation( foo_binder, FooBinder::MakeInstance, ArgRef( foo1 ) ) );

  PCI( vm.Native().GetTop() );

    vm.NewSlot(
      MakeOperation( vm.Native(), NativeAPI::PushRootTable ),
      MakeOperation( vm.Native(), NativeAPI::PushString, Arg( "foo2" ) ),
      MakeOperation( foo_binder, FooBinder::MakeInstance, ArgRef( foo2 ) ) );
PCI( vm.Native().GetTop() );

    vm.DoFile( "../test/test2.nut" );
  }
  catch ( TtSquirrel::NativeAPIException& e ) {
    printf( "== Error ==========================\n" );
    PCSS( e.GetFunctionName() );
    PCSS( e.GetReason() );
  }
  
  return 0;
}
