#include <stdio.h>
#include <stdarg.h>

#include "tt_squirrel_exception.h"

#include "tt_squirrel_utility.h"

using namespace TtSquirrel;


int
TtSquirrel::Pushed( int index, int pushed )
{
  return index > 0 ? index : index - pushed;
}



void
TtSquirrel::DefaultPrintFunc( HSQUIRRELVM vm, const SQChar* s, ... )
{
  static_cast<void>( vm );

  va_list arglist;
  va_start( arglist, s );
  vprintf( s, arglist );
  va_end( arglist );
}


void
TtSquirrel::ObjectTypeCheck( ObjectType require, ObjectType actual )
{
  if ( require != actual ) {
    throw ObjectTypeException( require, actual );
  }
}

// -- TypeTag ------------------------------------------------------------
std::map<std::string, void*>
TypeTag::TABLE;

TypeTag::TypeTag( const std::type_info& type ) :
tag_( NULL )
{
  if ( TABLE.find( type.name() ) == TABLE.end() ) {
    TABLE[type.name()] = new int( 0 );
  }
  tag_ = TABLE[type.name()];
}

void*
TypeTag::GetTag( void ) const
{
  return tag_;
}

TypeTag::operator void*( void )
{
  return this->GetTag();
}
