#ifndef TT_DIALOG_H_
#define TT_DIALOG_H_

#include "tt_form.h"

// -- TtDialog -----------------------------------------------------------
class TtDialog : public TtForm {
protected:
  static BOOL CALLBACK WindowProcedureForTTLDialog( HWND handle, UINT msg, WPARAM w_param, LPARAM l_param );

protected:
  virtual DWORD  GetStyle( void );
  virtual DWORD  GetExtendedStyle( void );
  virtual bool Created( void );

  virtual LRESULT DefaultWindowProcedure( UINT msg, WPARAM w_param, LPARAM l_param );
  virtual LRESULT WMCloseReceived( void );
  virtual LRESULT WMDestroyReceived( void );

public:
  virtual LRESULT WindowProcedure( UINT msg, WPARAM w_param, LPARAM l_param );

  explicit TtDialog( void );
  virtual ~TtDialog( void );

  virtual void CreatePrimitive( CreateParameter& parameter );

  virtual int ShowDialog( TtForm& parent );
  virtual void EndDialog( int result );

  int GetResult( void );

protected:
  void*   template_object_;
  int     dialog_result_;
};


// -- TtDialogModeless ---------------------------------------------------
class TtDialogModeless : public TtDialog {
public:
  explicit TtDialogModeless( void );

  virtual ~TtDialogModeless();

  virtual int ShowDialog( TtForm& parent );
  virtual void EndDialog( int result );
};


#endif // TT_DIALOG_H_
