#ifndef TT_DIRECTORY_H_
#define TT_DIRECTORY_H_

#include <string>
#include <vector>

class TtDirectory {
public:
  explicit TtDirectory( const std::string& path );

  const std::string& GetPath( void ) const;

  typedef bool (*FilteringFunction)( const std::string& path );

  std::vector<std::string> GetEntries( const std::string& path, FilteringFunction filter = NULL ) const;
  std::vector<std::string> GetEntriesRecursive( const std::string& path, FilteringFunction filter = NULL ) const;

private:
  std::string self_path_;
};

#endif // TT_DIRECTORY_H_
