#ifndef TT_FORM_H_
#define TT_FORM_H_

#include <set>

#include "tt_window.h"
#include "tt_menu.h"

// -- TtForm -------------------------------------------------------------
class TtForm : public TtWindow {
private:
  static const char* const CLASS_NAME;
  static std::set<TtForm*> FORM_TABLE;

public:
  static void Initialize( void );
  static void Initialize( HINSTANCE h_instance );
  static void RegisterClass( WNDCLASS* window_class );
  static WNDCLASS MakeDefaultWindowClass( HINSTANCE h_instance, const char* class_name );
  static int LoopDispatchMessage( void );

private:
  static bool IsDialogMessage( MSG* msg );

protected:
  virtual DWORD  GetStyle( void );
  virtual DWORD  GetExtendedStyle( void );
  virtual PCTSTR GetClassName( void );
  virtual bool Created( void );

  explicit TtForm( void );
  virtual ~TtForm();

  TtMenu GetSystemMenu( void );

  virtual LRESULT WMCloseReceived( void );
  virtual LRESULT WMDestroyReceived( void );
  virtual LRESULT WMCommandReceived( int id, int code, HWND child );
  virtual LRESULT WMNotifyReceived( int id, int code, HWND child );
  virtual LRESULT WMSizeReceived( int flag, int width, int height );
  virtual LRESULT WMPaintReceived( void );
  virtual LRESULT WMDropFilesReceived( HDROP drop );
  virtual LRESULT WMHorizontalScrollReceived( int code, int position, HWND handle );
  virtual LRESULT WMVerticalScrollReceived( int code, int position, HWND handle );

public:
  virtual LRESULT WindowProcedure( UINT msg, WPARAM w_param, LPARAM l_param );


protected:
  int exit_code_;
};

#endif // TT_FORM_H_
