#ifndef TT_IMAGE_LIST_H_
#define TT_IMAGE_LIST_H_

#include <windows.h>
#include <commctrl.h>

#include "tt_bmp_image.h"

class TtImageList {
public:
  explicit TtImageList( int width, int height );
  explicit TtImageList( int width, int height, unsigned int flags );
  explicit TtImageList( int width, int height, unsigned int flags, int initial, int grow );
  explicit TtImageList( HIMAGELIST handle, bool auto_destory );
  ~TtImageList();

  HIMAGELIST GetHandle( void );

  bool GetAutoDestory( void );
  void SetAutoDestory( bool flag );

  void Destroy( void );

  void AddIcon( HICON icon );
  void AddBitmap( const TtBmpImage& image );
  void AddBitmap( const TtBmpImage& image, const TtBmpImage& mask );
  void AddBitmapMasked( const TtBmpImage& image );
  void AddBitmapMasked( const TtBmpImage& image, int mask_color );

private:
  HIMAGELIST handle_;
  bool       auto_destroy_;
};

#endif // TT_IMAGE_LIST_H_
