#ifndef TT_LIST_H_
#define TT_LIST_H_

#include "tt_window.h"

// -- TtList -------------------------------------------------------------
class TtList : public BasedOnTtWindow<WS_TABSTOP, WS_EX_CLIENTEDGE, TtWindowClassName::LISTBOX> {
public:
  int GetCount( void );
  std::string GetTextAt( unsigned int index );
  int GetCurrent( void );
  int Find( unsigned int start, const std::string& str );

  int Push( const std::string& str );
  int InsertAt( unsigned int index, const std::string& str );

  int DeleteAt( unsigned int index );
  void Clear( void );

  int GetSelectedCount( void );
  bool IsSelect( unsigned int index );
  int SetSelect( unsigned int index );
  int UnsetSelect( unsigned int index );

  int LockDraw( void );
  int UnlockDraw( void );
};

#endif // TT_LIST_H_
