#ifndef TT_MENU_H_
#define TT_MENU_H_

#include "tt_window.h"

class TtMenu;

// -- TtMenuItem ---------------------------------------------------------
class TtMenuItem {
  friend class TtMenu;

private:
  explicit TtMenuItem( TtMenu& parent, unsigned int id_or_index, bool has_id );

public:
  ~TtMenuItem();

  void SetEnabled( bool flag );

private:
  TtMenu&      parent_;
  unsigned int id_or_index_;
  bool         has_id_;
};


// -- TtMenu -------------------------------------------------------------
class TtMenu {
public:
  explicit TtMenu( TtWindow& parent );
  explicit TtMenu( TtWindow& parent, const std::string& name );
  explicit TtMenu( TtWindow& parent, const std::string& name, bool auto_destroy );

  explicit TtMenu( HMENU handle, TtWindow& parent, bool auto_destroy );

private:
  explicit TtMenu( const TtMenu& root, int index );

public:
  ~TtMenu();

  void SetAutoDestroy( bool flag );

  HMENU GetHandle( void ) const;

  TtMenuItem GetItemAt( unsigned int index );
  TtMenuItem GetItemById( unsigned int id );
  TtMenu GetSubMenuAt( unsigned int index ) const;

  void TrackPopup( int x, int y ) const;
  void TrackPopupRelative( int x, int y ) const;
  void TrackPopupPrimitive( int x, int y, int flags ) const;

private:
  HMENU     handle_;
  TtWindow& parent_;
  bool      auto_destroy_;
};

#endif // TT_MENU_H_
