#ifndef TT_PATH_H_
#define TT_PATH_H_

#include <string>

namespace TtPath {
  // pX̔E
  bool IsDirectory( const std::string& path );
  bool IsFileSpec(  const std::string& path );
  bool IsRelative(  const std::string& path );
  bool IsRoot(      const std::string& path );
  bool MatchSpec(   const std::string& path, const std::string& match );

  bool FileExists(  const std::string& path );

  // Ȃ
  std::string FindFileName( const std::string& path );
  std::string FindExtension( const std::string& path );

  // ҏWȂ
  std::string EditPath( const std::string& path, bool f_drive, bool f_dir, bool f_fname, bool f_ext );
  std::string DirName( const std::string& path );
  std::string BaseName( const std::string& path );
  std::string CompactPath( const std::string& src, unsigned int max );
  std::string QuoteIfHasSpaces( const std::string& path );
  std::string ChangeExtension( const std::string& path, const std::string& ext );

  // 擾Ȃ
  std::string GetExecutingFilePath( void );
  std::string GetExecutingFilePathWithoutExtension( void );
  std::string GetExecutingFilePathCustomExtension( const std::string& extension );
  std::string GetExpandPath( const std::string& path );
}

#endif // TT_PATH_H_
