#ifndef TT_SCROLL_H_
#define TT_SCROLL_H_

#include "tt_window.h"

// -- TtScroll -----------------------------------------------------------
class TtScroll : public BasedOnTtWindow<0, WS_EX_CLIENTEDGE, TtWindowClassName::SCROLLBAR> {
public:
  int GetTrackPosition( void );
  void SetTrackPosition( int position );

  int GetMinimum( void );
  void SetMinimum( int min );
  int GetMaximum( void );
  void SetMaximum( int max );
  void SetRange( int min, int max );

  int GetPageSize( void );
  void SetPageSize( int page_size );

protected:
  bool GetInfo( void );
  void SetInfo( void );

  LRESULT Scrolling( int code, int position );

protected:
  SCROLLINFO info_;
};

// -- TtScrollVertical ---------------------------------------------------
class TtScrollVertical : public TtWindowWithStyle<TtScroll, SBS_VERT> {
protected:
  virtual LRESULT WMVerticalScrollReceived( int code, int position, HWND handle );
};

// -- TtScrollHorizontal -------------------------------------------------
class TtScrollHorizontal : public TtWindowWithStyle<TtScroll, SBS_HORZ> {
protected:
  virtual LRESULT WMHorizontalScrollReceived( int code, int position, HWND handle );
};

#endif // TT_SCROLL_H_
