#ifndef TT_STRING_H_
#define TT_STRING_H_

#include <string>

namespace TtString {
  class Appender {
  public:
    explicit Appender( std::string& str );

    template <class TYPE>
    Appender& operator <<( const TYPE& value ) {
      str_.append( TtUtil::ToStringFrom( value ) );
      return *this;
    }

  private:
    std::string& str_;
  };

  std::string Replace( const std::string& source, const std::string& pattern, const std::string& replacement );

  std::string Strip( const std::string& source, bool left = true, bool right = true );
  void StripDirect( std::string& source, bool left = true, bool right = true );

  bool StartWith( const std::string& source, const std::string& pattern );
  bool StartWith( const std::string& source, unsigned int start, const std::string& pattern );
  bool EndWith( const std::string& source, const std::string& pattern );

  std::string SubstringFromTo( const std::string& source, unsigned int from, unsigned int to );
}

#endif // TT_STRING_H_
