#ifndef TT_TAB_H_
#define TT_TAB_H_

#include <map>
#include <vector>
#include <set>

#include "tt_window.h"

// -- TtTab --------------------------------------------------------------
class TtTab : public BasedOnTtWindow<WS_TABSTOP, 0, TtWindowClassName::TABCONTROL> {
public:
  int GetCount( void );

  int InsertAt( int index, const std::string& str );

  int DeleteAt( int index );
  int Clear( void );

  int SetCurrent( int index );
  int GetCurrent( void );

  RECT GetViewRect( void );

  void RegistControl( unsigned int index, TtWindow& control );
  void RegistControl( unsigned int index, TtWindow& control, bool visible );

  // call at TCN_SELCHANGING
  void SaveCurrentVisibleState( void );
  void HideCurrentRegistedControls( void );

  // call at TCN_SELCHANGE
  void LoadCurrentVisibleState( void );

private:
  typedef std::pair<bool, bool> ControlState;
  std::map<TtWindow*, ControlState>  control_last_state_;
  std::vector< std::set<TtWindow*> > control_set_;
};

#endif // TT_TAB_H_
