#ifndef TT_TRACK_H_
#define TT_TRACK_H_

#include "tt_window.h"

// -- TtTrack ------------------------------------------------------------
class TtTrack : public BasedOnTtWindow<TBS_AUTOTICKS, 0, TtWindowClassName::TRACKBAR> {
public:
  int GetTrackPosition( void );
  void SetTrackPosition( int position );

  int GetMinimum( void );
  void SetMinimum( int min );
  int GetMaximum( void );
  void SetMaximum( int max );
  void SetRange( int min, int max );

  int GetPageSize( void );
  void SetPageSize( int page_size );

  int GetLineSize( void );
  void SetLineSize( int line_size );

  void SetTickFrequency( unsigned int frequency );
  void ClearTick( void );

protected:
  virtual LRESULT WMVerticalScrollReceived( int code, int position, HWND handle );
  virtual LRESULT WMHorizontalScrollReceived( int code, int position, HWND handle );
};

// -- TtTrackVertical ----------------------------------------------------
typedef TtWindowWithStyle<TtTrack, TBS_VERT>
TtTrackVertical;

// -- TtTrackHorizontal --------------------------------------------------
typedef TtWindowWithStyle<TtTrack, TBS_HORZ>
TtTrackHorizontal;

#endif // TT_TRACK_H_
