#ifndef TT_WINDOW_CONTROLS_H_
#define TT_WINDOW_CONTROLS_H_

#include "tt_window.h"

// -- TtStatic -----------------------------------------------------------
typedef BasedOnTtWindow<0, 0, TtWindowClassName::STATIC>
TtStatic;

// -- TtButton -----------------------------------------------------------
typedef BasedOnTtWindow<WS_TABSTOP, 0, TtWindowClassName::BUTTON>
TtButton;

// -- TtButtonWithCheck --------------------------------------------------
class TtButtonWithCheck : public TtButton {
public:
  bool GetCheck( void );
  int SetCheck( bool checking );
};

// -- TtRadioButton ------------------------------------------------------
typedef TtWindowWithStyle<TtButtonWithCheck, BS_AUTORADIOBUTTON>
TtRadioButton;

// -- TtCheckBox ----------------------------------------------------------
typedef TtWindowWithStyle<TtButtonWithCheck, BS_CHECKBOX | BS_AUTOCHECKBOX>
TtCheckBox;

// -- TtGroup ------------------------------------------------------------
typedef TtWindowWithStyle<TtButton, BS_GROUPBOX>
TtGroup;

// -- TtEdit -------------------------------------------------------------
class TtEdit : public BasedOnTtWindow<WS_TABSTOP | ES_AUTOHSCROLL, WS_EX_CLIENTEDGE, TtWindowClassName::EDIT> {
public:
  class Style {
  public:
    static const DWORD AUTOHSCROLL = ES_AUTOHSCROLL;
    static const DWORD AUTOVSCROLL = ES_AUTOVSCROLL;
    static const DWORD CENTER      = ES_CENTER;
    static const DWORD LEFT        = ES_LEFT;
    static const DWORD RIGHT       = ES_RIGHT ;
    static const DWORD UPPERCASE   = ES_UPPERCASE ;
    static const DWORD LOWERCASE   = ES_LOWERCASE;
    static const DWORD NUMBER      = ES_NUMBER;
    static const DWORD PASSWORD    = ES_PASSWORD ;
    static const DWORD MULTILINE   = ES_MULTILINE;
    static const DWORD WANTRETURN  = ES_WANTRETURN;
    static const DWORD READONLY    = ES_READONLY ;
  };

public:
  void SetReadOnly( bool flag );

  int GetFirstVisibleLine( void );
};

// -- TtEditWithStyle ----------------------------------------------------
template <DWORD style>
class TtEditWithStyle : public TtWindowWithStyle<TtEdit, style> {
};

typedef TtEditWithStyle<TtEdit::Style::NUMBER>
TtEditNumber;

typedef TtEditWithStyle<TtEdit::Style::MULTILINE | TtEdit::Style::WANTRETURN>
TtEditMultiline;

#endif // TT_WINDOW_CONTROLS_H_
