#ifndef TT_WINDOW_UTIL_H_
#define TT_WINDOW_UTIL_H_

#include <map>

#include "tt_window_controls.h"

// -- TtValueToRadioCheck ------------------------------------------------
template <class TYPE>
class TtValueToRadioCheck {
public:
  explicit TtValueToRadioCheck( TtRadioButton& default_radio ) :
  table_(), default_radio_( default_radio ) {}

  void Regist( TYPE value, TtRadioButton& radio ) {
    table_[value] = &radio;
  }

  void SetCheck( TYPE value ) {
    if ( table_.find( value ) != table_.end() ) {
      table_[value]->SetCheck( true );
    }
    else {
      default_radio_.SetCheck( true );
    }
  }

private:
  std::map<TYPE, TtRadioButton*> table_;
  TtRadioButton&                 default_radio_;
};


// -- TtRadioCheckToValue ------------------------------------------------
template <class TYPE>
class TtRadioCheckToValue {
public:
  explicit TtRadioCheckToValue( TYPE default_value ) :
  table_(), default_value_( default_value ) {}

  void Regist( TtRadioButton& radio, TYPE value ) {
    table_[&radio] = value;
  }

  TYPE GetValue( void ) const {
    for ( std::map<TtRadioButton*, TYPE>::const_iterator it = table_.begin(); it != table_.end(); ++it ) {
      if ( it->first->GetCheck() ) {
        return it->second;
      }
    }
    return default_value_;
  }

private:
  std::map<TtRadioButton*, TYPE> table_;
  TYPE                           default_value_;
};

#endif // TT_WINDOW_UTIL_H_
