#ifndef TTL_DEFINE_H_
#define TTL_DEFINE_H_

#ifndef NOT_USE_VAR
#define NOT_USE_VAR( var ) ((void)var)
#endif

#ifndef NOT
#define NOT( v ) (!(v))
#endif

#define REAL_FUNC_NAME_OF( f ) (#f)
#ifdef DEBUG
#  define FUNC_NAME_OF( f ) ((void)(f), (*(f)) == ((f)), #f)
#else
#  define FUNC_NAME_OF( f ) (#f)
#endif

#ifdef DEBUG
#  include <stdio.h>
#  include <string>
#  define FILENAME__       (__FILE__ + std::string( __FILE__ ).find_last_of( '\\' ) + 1)
#  define PCD()            printf( "%s(%d) gone.\n", FILENAME__, __LINE__ )
#  define PCA( type, obj ) printf( "%s(%d) : %s = " type "\n", FILENAME__, __LINE__, #obj, (obj) )
#  define PCC( c )         PCA( "%c", c )
#  define PCI( i )         PCA( "%d", i )
#  define PCP( p )         PCA( "%p", p )
#  define PCS( s )         PCA( "%s", s )
#  define PCF( f )         PCA( "%f", f )
#  define PCSS( s )        printf( "%s(%d) : %s = %s\n", FILENAME__, __LINE__, #s, (s).c_str() )

#  include "tt_util.h"
#  define PMD()            TtUtil::MessageBoxForDebug( "", "gone", 0, FILENAME__, __LINE__ )
#  define PMA( type, obj ) TtUtil::MessageBoxForDebug( type, #obj, (void*)(obj), FILENAME__, __LINE__ )
#  define PMC( c )         PMA( "%c", c )
#  define PMI( i )         PMA( "%d", i )
#  define PMP( p )         PMA( "%p", p )
#  define PMS( s )         PMA( "%s", s )
#  define PMF( f )         PMA( "%f", f )
#  define PMSS( s )        TtUtil::MessageBoxForDebug( "%s", #s, (void*)((s).c_str()), __FILE__, __LINE__ )
#endif

#endif // TTL_DEFINE_H_
